Bug 506840 - Problem in freetype causes navit to crash unless freetype is built with -fno-strict-aliasing
Summary: Problem in freetype causes navit to crash unless freetype is built with -fno-...
Keywords:
Status: CLOSED DUPLICATE of bug 513582
Alias: None
Product: Fedora
Classification: Fedora
Component: freetype
Version: rawhide
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Behdad Esfahbod
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-06-18 20:55 UTC by Adam Williamson
Modified: 2009-07-29 16:54 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-07-29 16:54:55 UTC


Attachments (Terms of Use)

Description Adam Williamson 2009-06-18 20:55:45 UTC
I encountered a problem running SVN navit (a GPS navigation app) on F11 and then Rawhide; it would crash as soon as it tried to render any text.

I reported this upstream, and the upstream developer Martin Schaller very kindly investigated this extensively. He was able to isolate it to a problem in freetype. I quote:

"I think I got something
<cp15> Can you find out what compiler flags are used to compile freetype on redhat?
<cp15> Because it seems freetype exibits a bug when compiled without -fno-strict-aliasing
...
<adamw> OK...so this is really a bug in freetype we should report and get fixed, building with -fno-strict-aliasing is just a workaround, right?
<cp15> Well... Hmm... without -fno-strict-aliasing gcc makes some optimizations which are probably not expected by freetype. Hard to say where the bug is
<adamw> yes! that does the trick indeed
 ok, so...file a bug on freetype. can you give me some more details to include? do you know exactly where it goes wrong?
<cp15> I can only tell that it crashes in ftccmap.c line 382 at FT_ASSERT( (FT_UInt)( char_code - node->first ) < FTC_CMAP_INDICES_MAX ); because node seems to be corrupted or NULL or at line cmap = face->charmaps[cmap_index]; because face->charmaps seems to be corrupted
 Should have been line 406 in the second part"

So, that's what we know about the problem. Please ask if you need any more details. A .src.rpm for navit which you can rebuild to reproduce the problem can be found at http://adamwill.fedorapeople.org/navit/navit-0.1.1-0.1.2347.aw_fc12.src.rpm . Run it with a stock Fedora freetype, and it fails. Run it with stock Rawhide freetype unchanged except by adding -fno-strict-aliasing to CFLAGS, and it works.

Comment 1 Adam Williamson 2009-06-18 20:56:21 UTC
Adding Martin to CC, he can provide any further details that might help.

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers

Comment 2 udo 2009-06-19 03:20:18 UTC
Problem also seen here.

Comment 3 Kevin Kofler 2009-07-29 16:54:55 UTC
Closing as a duplicate of the more recent report which has a patch attached.

The fix got pushed to F11 now.

*** This bug has been marked as a duplicate of bug 513582 ***


Note You need to log in before you can comment on or make changes to this bug.